intracdc/apps/accounts/urls.py
from django.urls import path
from .views import ProfileView, PreferencesView, TrombiView

app_name = "accounts"

urlpatterns = [
    path("profile/<str:username>", ProfileView.as_view(), name="profile"),
    path("preferences", PreferencesView.as_view(), name="preferences"),
    path("trombi", TrombiView.as_view(), name="trombi"),
]

intracdc/urls.py
from rest_framework.decorators import api_view
from rest_framework.response import Response
from rest_framework.reverse import reverse

from django.conf import settings
from django.contrib import admin
from django.urls import include, path


# pylint: disable=redefined-builtin
@api_view(["GET"])
def api_root(request, format=None):
    return Response(
        {
            "accounts": reverse(
                "api_accounts:api-root", request=request, format=format
            ),
            "projects": reverse(
                "api_projects:api-root", request=request, format=format
            ),
            "themes": reverse(
                "api_themes:api-root", request=request, format=format
            ),
        }
    )


urlpatterns = [
    path("admin/", admin.site.urls),
    path("markdownx/", include("markdownx.urls")),
    path("api/", api_root),
    path(
        "api/accounts/", include("accounts.api_urls", namespace="api_accounts")
    ),
    path(
        "api/projects/", include("projects.api_urls", namespace="api_projects")
    ),
    path("api/themes/", include("themes.api_urls", namespace="api_themes")),
    path(
        "api-auth/", include("rest_framework.urls", namespace="rest_framework")
    ),
    path("", include("home.urls", namespace="home")),
    path("accounts/", include("accounts.urls", namespace="accounts")),
    path("accounts/", include("social_django.urls", namespace="social")),
    path("projects/", include("projects.urls", namespace="projects")),
]

if settings.DEBUG:
    import debug_toolbar

    urlpatterns = [
        path("__debug__/", include(debug_toolbar.urls))
    ] + urlpatterns

intracdc/apps/accounts/models.py
from django.contrib.auth.models import AbstractUser
from django.db import models


class Campus(models.Model):
    name = models.CharField(max_length=255)

    class Meta:
        verbose_name_plural = "Campuses"

    def __str__(self):
        return f"{self.name}"


class Semester(models.Model):
    number = models.SmallIntegerField()
    is_sharp = models.BooleanField(default=False)
    promotion = models.SmallIntegerField()

    def __str__(self):
        return f"{self.promotion} S{self.number}{'#' if self.is_sharp else ''}"


class Class(models.Model):
    name = models.CharField(max_length=255)
    campus = models.ForeignKey("Campus", on_delete=models.PROTECT)
    semester = models.ForeignKey("Semester", on_delete=models.PROTECT)

    class Meta:
        verbose_name_plural = "Classes"

    def __str__(self):
        return f"{self.campus} - {self.semester} - {self.name}"


class Account(AbstractUser):
    pseudo = models.CharField(max_length=255, blank=True)
    theme = models.ForeignKey(
        "themes.Theme",
        on_delete=models.PROTECT,
        limit_choices_to={"datedtheme": None},
    )
    current_class = models.ForeignKey(
        "Class", on_delete=models.PROTECT, null=True, blank=True
    )
    past_classes = models.ManyToManyField(
        "Class", related_name="past_classes", blank=True
    )

    def is_student(self):
        return self.groups.filter(name="Students").exists()

    def __str__(self):
        return f"{self.username}"

    def __lt__(self, other):
        return self.username < other.username

intracdc/apps/accounts/forms.py
from django import forms
from django.contrib.auth import get_user_model


class PreferencesForm(forms.ModelForm):
    class Meta:
        model = get_user_model()
        fields = [
            "pseudo",
            "theme",
        ]

intracdc/apps/accounts/views.py
from django.contrib.auth import get_user_model
from django.contrib.auth.mixins import (
    LoginRequiredMixin,
    PermissionRequiredMixin,
)
from django.contrib.auth.models import Group
from django.shortcuts import get_object_or_404, render
from django.views.generic import TemplateView

from .forms import PreferencesForm
from .utils import order_dict


class ProfileView(PermissionRequiredMixin, TemplateView):
    permission_required = "accounts.can_view_user"
    template_name = "accounts/profile.html"

    def get(self, request, *args, **kwargs):
        context = {
            "user": get_object_or_404(
                get_user_model(), username=kwargs["username"]
            ),
        }
        return render(request, self.template_name, context)


class PreferencesView(LoginRequiredMixin, TemplateView):
    template_name = "accounts/preferences.html"

    def get(self, request, *args, **kwargs):
        context = {"form": PreferencesForm(instance=request.user)}
        return render(request, self.template_name, context)

    # pylint:disable=unused-argument
    def post(self, request, *args, **kwargs):
        form = PreferencesForm(request.POST, instance=request.user)
        if form.is_valid():
            edited_user = form.save()
            edited_user.save()
        context = {
            "form": form,
        }
        return render(request, self.template_name, context)


class TrombiView(LoginRequiredMixin, TemplateView):
    template_name = "accounts/trombi.html"

    def get(self, request, *args, **kwargs):
        promotions_by_group = {}
        for group in Group.objects.all():
            if group.name == "CRI":
                continue
            promotions = {}

            for user in group.user_set.all():
                if user.current_class is None:
                    continue
                if user.current_class.semester.promotion not in promotions:
                    promotions[user.current_class.semester.promotion] = {}
                if (
                    user.current_class.name
                    not in promotions[user.current_class.semester.promotion]
                ):
                    promotions[user.current_class.semester.promotion][
                        user.current_class.name
                    ] = []
                promotions[user.current_class.semester.promotion][
                    user.current_class.name
                ].append(user)

            promotions_by_group[group.name] = promotions

        context = {
            "promotions_by_group": order_dict(promotions_by_group),
        }
        return render(request, self.template_name, context)

intracdc/apps/accounts/templates/accounts/preferences.html
{% extends "base.html" %}

{% block content %}
<vstack spacing="s" id="app">
  <h2>Preferences</h2>
  <hr>

  <section v-if="errored">
    <hstack stretch responsive align-x="center">
      <div class="pa3 br3" style="background-color: #fc2222;">
        We're sorry, we're not able to retrieve this information at the moment, please try back later.
      </div>
    </hstack>
  </section>

  <section v-else>
    <vstack stretch align-x="center" align-y="center" v-if="loading">
      <div class="loader"></div>
    </vstack>

    <vstack v-else>
      <form method="post" enctype="multipart/form-data">
        <hstack responsive spacing="m">
          <label for="id_first_name">First name:</label>
          <input stretch type="text" name="first_name" v-model="user.first_name" maxlength="255" id="id_first_name">

          <label for="id_last_name">Last name:</label>
          <input stretch type="text" name="last_name" v-model="user.last_name" maxlength="255" id="id_last_name">
        </hstack>
        <br />
        <hstack responsive spacing="m">
          <label for="id_pseudo">Pseudo:</label>
          <input stretch type="text" name="pseudo" v-model="user.pseudo" maxlength="255" id="id_pseudo">

          <label for="id_theme">Theme:</label>
          <select stretch name="theme" required id="id_theme" v-model="user_theme.url">
            <option disabled value="">Please select a theme</option>
            <option v-for="theme in themes" v-bind:value="theme.url">
              ${ theme.name }
            </option>
          </select>
        </hstack>
        <br />
        <input type="submit" v-on:click="submit" value="Save">
      </form>
    </vstack>
  </section>
</vstack>

<script>
  axios.defaults.xsrfCookieName = "csrftoken";
  axios.defaults.xsrfHeaderName = "X-CSRFToken";
  new Vue({
    delimiters: ["${", "}"],
    el: "#app",
    data() {
      return {
        user: {
          first_name: "",
          last_name: "",
          pseudo: "",
          theme: "",
        },
        user_theme: {},
        themes: [],
        loading: true,
        errored: false,
      }
    },

    mounted() {
      this.fetchData();
    },

    methods: {
      submit: async function() {
        this.loading = true;
        var response = await axios
          .patch("/api/accounts/users/{{ user.pk }}/", {
            first_name: this.user.first_name,
            last_name: this.user.last_name,
            pseudo: this.user.pseudo,
            theme: this.user_theme.url
          })
          .catch(error => {
            console.log(error);
            this.loading = false;
            return
          });
        this.fetchData();
      },

      fetchData: async function() {
        this.loading = true;
        this.errored = false;

        var response = await axios.get("/api/accounts/users/{{ user.pk }}/")
          .catch(error => {
            console.log(error);
            this.errored = true;
            this.loading = false;
            return
          });
        this.user = response.data;

        var response = await axios.get("/api/themes/themes/")
          .catch(error => {
            console.log(error);
            this.errored = true;
            this.loading = false;
            return
          });
        this.themes = response.data["results"];

        this.user_theme = (await axios.get(this.user.theme)).data;

        this.loading = false;
      },
    },
  });
</script>
{% endblock %}

intracdc/apps/accounts/templates/accounts/profile.html
{% extends 'base.html' %}

{% block content %}
<vstack spacing="s" id="app">
  <h2>Profile</h2>
  <hr>

  <section v-if="errored">
    <hstack stretch responsive align-x="center">
      <div class="pa3 br3" style="background-color: #fc2222;">
        We're sorry, we're not able to retrieve this information at the moment, please try back later.
      </div>
    </hstack>
  </section>

  <section v-else>
    <vstack stretch align-x="center" align-y="center" v-if="loading">
      <div class="loader"></div>
    </vstack>

    <hstack responsive spacing="s" v-else>
      <aside style="width: 30%;">
        <vstack class="pa3">
          <img v-bind:src="`${ user.profile_picture }`">
        </vstack>
      </aside>

      <aside stretch>
        <dl>
          <vstack class="pa2">
            <vstack class="pa2">
              <h3>Informations</h3>
            </vstack>
            <hr>

            <vstack spacing="m" class="pa3">
              <hstack responsive spacing="s">
                <vstack>
                  <dt>Username</dt>
                  <dd>${ user.username }</dd>
                </vstack>
                <vstack>
                  <dt>Email address</dt>
                  <dd>${ user.email }</dd>
                </vstack>
              </hstack>

              <hstack responsive spacing="s">
                <vstack>
                  <dt>First name</dt>
                  <dd>${ user.first_name }</dd>
                </vstack>
                <vstack>
                  <dt>Last name</dt>
                  <dd>${ user.last_name }</dd>
                </vstack>
              </hstack>

              <hstack responsive spacing="s">
                <vstack>
                  <dt>Pseudo</dt>
                  <dd>${ user.pseudo }</dd>
                </vstack>
                <vstack>
                  <dt>Theme</dt>
                  <dd>${ theme }</dd>
                </vstack>
              </hstack>

              <hstack responsive spacing="s">
                <vstack>
                  <dt>Current class</dt>
                  <dd>${ current_class.display_name }</dd>
                </vstack>
                <vstack>
                  <dt>Past classes</dt>
                  <dd>
                    <ul v-for="past_class in past_classes">
                      <li>${ past_class.display_name }</li>
                    </ul>
                  </dd>
                </vstack>
              </hstack>
            </vstack>
          </vstack>
        </dl>
      </aside>
    </hstack>
  </section
</vstack>

<script>
  new Vue({
    delimiters: ["${", "}"],
    el: "#app",
    data() {
      return {
        user: {
          username: "",
          first_name: "",
          last_name: "",
          pseudo: "",
          theme: "",
          profile_picture: "",
          current_class: "",
          past_classes: [],
        },
        theme: "",
        current_class: "",
        past_classes: [],
        loading: true,
        errored: false,
      }
    },

    mounted() {
      this.intervalFetchData();
    },

    methods: {
      fetchData: async function() {
        this.loading = true;
        this.errored = false;

        var response = await axios.get("/api/accounts/users/{{ user.pk }}")
          .catch(error => {
            console.log(error);
            this.errored = true;
            this.loading = false;
            return
          });
        this.user = response.data;

        this.theme = (await axios.get(this.user.theme)).data.name;
        this.current_class = (await axios.get(this.user.current_class)).data;

        var past_classes = [];
        this.user.past_classes.forEach(async function(past_class, index) {
          var response = await axios.get(past_class);
          past_classes.push(response.data);
        });
        this.past_classes = past_classes;

        this.loading = false;
      },

      intervalFetchData: function() {
        this.fetchData();
        setInterval(() => {
          this.fetchData()
        }, 5000);
      },
    },
  })
</script>
{% endblock %}

intracdc/apps/accounts/templates/accounts/trombi.html
{% extends 'base.html' %}

{% block content %}
<vstack spacing="s">
  <h2>Trombi</h2>
  <hr>
  <vstack x-data="{ group_active: '', promotion_active: '', classe_active: '' }">
    <hstack stretch="" spacing="xs">
      {% for group, _ in promotions_by_group.items %}
      <a href="" @click.prevent="group_active = '{{ group }}'" class="pv1 mv1 ph3 br3" :class="{ 'bg-link background-alt': group_active === '{{ group }}' }">{{ group }}</a>
      {% endfor %}
    </hstack>
    {% for group, promotions in promotions_by_group.items %}
    <vstack stretch="" x-show="group_active === '{{ group }}'">
      <hstack stretch="" spacing="xs">
        {% for promotion, _ in promotions.items %}
        <a href="" @click.prevent="promotion_active = '{{ promotion }}'" class="pv1 mv1 ph3 br3" :class="{ 'bg-link background-alt': promotion_active === '{{ promotion }}' }">{{ promotion }}</a>
        {% endfor %}
      </hstack>
      {% for promotion, classes in promotions.items %}
      <vstack stretch="" x-show="promotion_active === '{{ promotion }}'">
        <hstack stretch="" spacing="xs">
          <a href="" @click.prevent="classe_active = '__ALL__'" class="pv1 mv1 ph3 br3" :class="{ 'bg-link background-alt': classe_active === '__ALL__' }">All</a>
          {% for classe, _ in classes.items %}
          <a href="" @click.prevent="classe_active = '{{ classe }}'" class="pv1 mv1 ph3 br3" :class="{ 'bg-link background-alt': classe_active === '{{ classe }}' }">{{ classe }}</a>
          {% endfor %}
        </hstack>
        {% for classe, users in classes.items %}
        <vstack stretch="" x-show="classe_active === '{{ classe }}' || classe_active === '__ALL__'">
          <vstack x-show="classe_active === '__ALL__'">
            <h5>{{ classe }}</h5>
          </vstack>
          <hstack spacing="xs">
            {% for user in users %}
            <aside style="width: 20%;">
              <vstack stretch="" class="pa2" align-x="center">
                <img src="https://photos.cri.epita.fr/thumb/{{ user.username }}">
                <p style="word-break: break-all;"><a href="{% url "accounts:profile" user.username %}">{{ user.username }}</a></p>
              </vstack>
            </aside>
            {% endfor %}
          </hstack>
        </vstack>
        {% endfor %}
      </vstack>
      {% endfor %}
    </vstack>
    {% endfor %}
  </vstack>
</vstack>
{% endblock %}